Index: trunk/gui/scripts/contourresult.tcl
===================================================================
--- trunk/gui/scripts/contourresult.tcl	(revision 1342)
+++ trunk/gui/scripts/contourresult.tcl	(revision 1343)
@@ -477,7 +477,8 @@
 	}
 	now {
-	    # Get image data (as base64) and decode back to binary.  This is
-	    # better than writing to temporary files.  When we switch the BLT
-	    # picture image it won't be necessary to decode the image data.
+	    # Get the image data (as base64) and decode it back to binary.
+	    # This is better than writing to temporary files.  When we switch
+	    # to the BLT picture image it won't be necessary to decode the
+	    # image data.
 	    set bytes [$_download data -format "jpeg -quality 100"]
 	    set bytes [Rappture::encoding::decode -as b64 $bytes]
Index: trunk/gui/scripts/flowvisviewer.tcl
===================================================================
--- trunk/gui/scripts/flowvisviewer.tcl	(revision 1342)
+++ trunk/gui/scripts/flowvisviewer.tcl	(revision 1343)
@@ -775,8 +775,8 @@
 	    switch -- $_downloadPopup(format) {
 		jpg {
-		    # Get image data (as base64) and decode back to binary.
-		    # This is # better than writing to temporary files.  When
-		    # we switch the BLT # picture image it won't be necessary
-		    # to decode the image data.
+		    # Get the image data (as base64) and decode it back to
+		    # binary.  This is better than writing to temporary files.
+		    # When we switch to the BLT picture image it won't be
+		    # necessary to decode the image data.
 		    set bytes [$_image(download) data \
 				  -format "jpeg -quality 100"]
Index: trunk/gui/scripts/heightmapviewer.tcl
===================================================================
--- trunk/gui/scripts/heightmapviewer.tcl	(revision 1342)
+++ trunk/gui/scripts/heightmapviewer.tcl	(revision 1343)
@@ -493,7 +493,8 @@
 	}
 	now {
-	    # Get image data (as base64) and decode back to binary.  This is
-	    # better than writing to temporary files.  When we switch the BLT
-	    # picture image it won't be necessary to decode the image data.
+	    # Get the image data (as base64) and decode it back to binary.
+	    # This is better than writing to temporary files.  When we switch
+	    # to the BLT picture image it won't be necessary to decode the
+	    # image data.
 	    set bytes [$_image(download) data -format "jpeg -quality 100"]
 	    set bytes [Rappture::encoding::decode -as b64 $bytes]
Index: trunk/gui/scripts/imageresult.tcl
===================================================================
--- trunk/gui/scripts/imageresult.tcl	(revision 1342)
+++ trunk/gui/scripts/imageresult.tcl	(revision 1343)
@@ -309,7 +309,8 @@
 		return ""
 	    }
-	    # Get image data (as base64) and decode back to binary.  This is
-	    # better than writing to temporary files.  When we switch the BLT
-	    # picture image it won't be necessary to decode the image data.
+	    # Get the image data (as base64) and decode it back to binary.
+	    # This is better than writing to temporary files.  When we switch
+	    # to the BLT picture image it won't be necessary to decode the
+	    # image data.
 	    set bytes [$top data $tmpfile -format "jpeg -quality 100"]
 	    set bytes [Rappture::encoding::decode -as b64 $bytes]
Index: trunk/gui/scripts/moleculeViewer.tcl
===================================================================
--- trunk/gui/scripts/moleculeViewer.tcl	(revision 1342)
+++ trunk/gui/scripts/moleculeViewer.tcl	(revision 1343)
@@ -328,7 +328,8 @@
 	}
 	now {
-	    # Get image data (as base64) and decode back to binary.  This is
-	    # better than writing to temporary files.  When we switch the BLT
-	    # picture image it won't be necessary to decode the image data.
+	    # Get the image data (as base64) and decode it back to binary.
+	    # This is better than writing to temporary files.  When we switch
+	    # to the BLT picture image it won't be necessary to decode the
+	    # image data.
 	    set bytes [$_download data -format "jpeg -quality 100"]
 	    set bytes [Rappture::encoding::decode -as b64 $bytes]
Index: trunk/gui/scripts/molvisviewer.tcl
===================================================================
--- trunk/gui/scripts/molvisviewer.tcl	(revision 1342)
+++ trunk/gui/scripts/molvisviewer.tcl	(revision 1343)
@@ -547,8 +547,8 @@
 	    switch -- $_downloadPopup(format) {
 		jpg {
-		    # Get image data (as base64) and decode back to binary.
-		    # This is better than writing to temporary files.  When we
-		    # switch the BLT picture image it won't be necessary to
-		    # decode the image data.
+		    # Get the image data (as base64) and decode it back to
+		    # binary.  This is better than writing to temporary
+		    # files.  When we switch to the BLT picture image it
+		    # won't be necessary to decode the image data.
 		    set bytes [$_image(plot) data -format "jpeg -quality 100"]
 		    set bytes [Rappture::encoding::decode -as b64 $bytes]
Index: trunk/gui/scripts/nanovisviewer.tcl
===================================================================
--- trunk/gui/scripts/nanovisviewer.tcl	(revision 1342)
+++ trunk/gui/scripts/nanovisviewer.tcl	(revision 1343)
@@ -710,7 +710,8 @@
 	}
 	now {
-	    # Get image data (as base64) and decode back to binary.  This is
-	    # better than writing to temporary files.  When we switch the BLT
-	    # picture image it won't be necessary to decode the image data.
+	    # Get the image data (as base64) and decode it back to binary.
+	    # This is better than writing to temporary files.  When we switch
+	    # to the BLT picture image it won't be necessary to decode the
+	    # image data.
 	    set bytes [$_image(plot) data -format "jpeg -quality 100"]
 	    set bytes [Rappture::encoding::decode -as b64 $bytes]