Index: /trunk/configure
===================================================================
--- /trunk/configure	(revision 1465)
+++ /trunk/configure	(revision 1466)
@@ -15576,5 +15576,5 @@
 
 
-ac_config_files="$ac_config_files Makefile packages/Makefile src/Makefile src/core/Makefile src/core2/Makefile src/objects/Makefile src/objects/RpHash.h gui/Makefile gui/apps/Makefile gui/apps/about gui/apps/encodedata gui/apps/rappture gui/apps/rappture-csh.env gui/apps/rappture.env gui/apps/rerun gui/apps/simsim gui/apps/xmldiff gui/pkgIndex.tcl gui/scripts/Makefile lang/Makefile lang/perl/Makefile lang/perl/Makefile.PL lang/python/Makefile lang/python/setup.py lang/matlab/Makefile lang/octave/Makefile lang/octave/RpOctaveInterface.h lang/ruby/Makefile lang/ruby/build.rb lang/tcl/Makefile lang/tcl/pkgIndex.tcl lang/tcl/src/Makefile lang/tcl/scripts/Makefile lang/tcl/tests/Makefile lib/Makefile examples/3D/Makefile examples/Makefile examples/app-fermi/2.0/Makefile examples/app-fermi/Makefile examples/app-fermi/cee/Makefile examples/app-fermi/fortran/Makefile examples/app-fermi/matlab/Makefile examples/app-fermi/matlab/compiled/Makefile examples/app-fermi/matlab/uncompiled/Makefile examples/app-fermi/octave/Makefile examples/app-fermi/perl/Makefile examples/app-fermi/python/Makefile examples/app-fermi/ruby/Makefile examples/app-fermi/tcl/Makefile examples/app-fermi/wrapper/Makefile examples/app-fermi/wrapper/cee/Makefile examples/app-fermi/wrapper/python/Makefile examples/app-fermi/wrapper/tcl/Makefile examples/c-example/Makefile examples/canvas/Makefile examples/demo.bash examples/graph/Makefile examples/objects/Makefile examples/objects/axis/Makefile examples/objects/curve/Makefile examples/objects/dxWriter/Makefile examples/objects/floatBuffer/Makefile examples/objects/number/Makefile examples/objects/plot/Makefile examples/objects/string/Makefile examples/zoo/Makefile examples/zoo/binary/Makefile examples/zoo/boolean/Makefile examples/zoo/choice/Makefile examples/zoo/cloud/Makefile examples/zoo/cloud/matlab/Makefile examples/zoo/curve/Makefile examples/zoo/enable/Makefile examples/zoo/field/Makefile examples/zoo/group/Makefile examples/zoo/image/Makefile examples/zoo/image/docs/Makefile examples/zoo/image/examples/Makefile examples/zoo/integer/Makefile examples/zoo/integer2/Makefile examples/zoo/loader/Makefile examples/zoo/loader/examples/Makefile examples/zoo/loadrun/Makefile examples/zoo/log/Makefile examples/zoo/note/Makefile examples/zoo/note/docs/Makefile examples/zoo/number/Makefile examples/zoo/number2/Makefile examples/zoo/phase/Makefile examples/zoo/sequence/Makefile examples/zoo/sequence/examples/Makefile examples/zoo/string/Makefile examples/zoo/structure/Makefile examples/zoo/structure/examples/Makefile examples/zoo/table/Makefile examples/zoo/unirect2d/Makefile test/Makefile test/src/Makefile"
+ac_config_files="$ac_config_files Makefile packages/Makefile src/Makefile src/core/Makefile src/core2/Makefile src/objects/Makefile src/objects/RpHash.h gui/Makefile gui/apps/Makefile gui/apps/about gui/apps/encodedata gui/apps/rappture gui/apps/rappture-csh.env gui/apps/rappture.env gui/apps/rerun gui/apps/simsim gui/apps/xmldiff gui/pkgIndex.tcl gui/scripts/Makefile lang/Makefile lang/perl/Makefile lang/perl/Makefile.PL lang/python/Makefile lang/python/setup.py lang/matlab/Makefile lang/octave/Makefile lang/octave/RpOctaveInterface.h lang/ruby/Makefile lang/ruby/build.rb lang/tcl/Makefile lang/tcl/pkgIndex.tcl lang/tcl/src/Makefile lang/tcl/scripts/Makefile lang/tcl/tests/Makefile lib/Makefile examples/3D/Makefile examples/Makefile examples/app-fermi/2.0/Makefile examples/app-fermi/Makefile examples/app-fermi/cee/Makefile examples/app-fermi/fortran/Makefile examples/app-fermi/matlab/Makefile examples/app-fermi/matlab/compiled/Makefile examples/app-fermi/matlab/uncompiled/Makefile examples/app-fermi/octave/Makefile examples/app-fermi/perl/Makefile examples/app-fermi/python/Makefile examples/app-fermi/ruby/Makefile examples/app-fermi/tcl/Makefile examples/app-fermi/wrapper/Makefile examples/app-fermi/wrapper/cee/Makefile examples/app-fermi/wrapper/python/Makefile examples/app-fermi/wrapper/tcl/Makefile examples/c-example/Makefile examples/canvas/Makefile examples/demo.bash examples/flow/Makefile examples/flow/demo1/Makefile examples/flow/demo2/Makefile examples/flow/demo3/Makefile examples/graph/Makefile examples/objects/Makefile examples/objects/axis/Makefile examples/objects/curve/Makefile examples/objects/dxWriter/Makefile examples/objects/floatBuffer/Makefile examples/objects/number/Makefile examples/objects/plot/Makefile examples/objects/string/Makefile examples/zoo/Makefile examples/zoo/binary/Makefile examples/zoo/boolean/Makefile examples/zoo/choice/Makefile examples/zoo/cloud/Makefile examples/zoo/cloud/matlab/Makefile examples/zoo/curve/Makefile examples/zoo/enable/Makefile examples/zoo/field/Makefile examples/zoo/group/Makefile examples/zoo/image/Makefile examples/zoo/image/docs/Makefile examples/zoo/image/examples/Makefile examples/zoo/integer/Makefile examples/zoo/integer2/Makefile examples/zoo/loader/Makefile examples/zoo/loader/examples/Makefile examples/zoo/loadrun/Makefile examples/zoo/log/Makefile examples/zoo/note/Makefile examples/zoo/note/docs/Makefile examples/zoo/number/Makefile examples/zoo/number2/Makefile examples/zoo/phase/Makefile examples/zoo/sequence/Makefile examples/zoo/sequence/examples/Makefile examples/zoo/string/Makefile examples/zoo/structure/Makefile examples/zoo/structure/examples/Makefile examples/zoo/table/Makefile examples/zoo/unirect2d/Makefile test/Makefile test/src/Makefile"
 
 cat >confcache <<\_ACEOF
@@ -16232,4 +16232,8 @@
     "examples/canvas/Makefile") CONFIG_FILES="$CONFIG_FILES examples/canvas/Makefile" ;;
     "examples/demo.bash") CONFIG_FILES="$CONFIG_FILES examples/demo.bash" ;;
+    "examples/flow/Makefile") CONFIG_FILES="$CONFIG_FILES examples/flow/Makefile" ;;
+    "examples/flow/demo1/Makefile") CONFIG_FILES="$CONFIG_FILES examples/flow/demo1/Makefile" ;;
+    "examples/flow/demo2/Makefile") CONFIG_FILES="$CONFIG_FILES examples/flow/demo2/Makefile" ;;
+    "examples/flow/demo3/Makefile") CONFIG_FILES="$CONFIG_FILES examples/flow/demo3/Makefile" ;;
     "examples/graph/Makefile") CONFIG_FILES="$CONFIG_FILES examples/graph/Makefile" ;;
     "examples/objects/Makefile") CONFIG_FILES="$CONFIG_FILES examples/objects/Makefile" ;;
Index: /trunk/configure.in
===================================================================
--- /trunk/configure.in	(revision 1465)
+++ /trunk/configure.in	(revision 1466)
@@ -545,4 +545,8 @@
     examples/canvas/Makefile
     examples/demo.bash
+    examples/flow/Makefile
+    examples/flow/demo1/Makefile
+    examples/flow/demo2/Makefile
+    examples/flow/demo3/Makefile
     examples/graph/Makefile
     examples/objects/Makefile
Index: /trunk/examples/Makefile.in
===================================================================
--- /trunk/examples/Makefile.in	(revision 1465)
+++ /trunk/examples/Makefile.in	(revision 1466)
@@ -24,4 +24,5 @@
 		c-example \
 		canvas \
+		flow \
 		graph \
 		objects \
Index: /trunk/examples/flow/Makefile.in
===================================================================
--- /trunk/examples/flow/Makefile.in	(revision 1466)
+++ /trunk/examples/flow/Makefile.in	(revision 1466)
@@ -0,0 +1,45 @@
+
+bindir          = @bindir@
+datadir		= @datadir@
+datarootdir	= @datarootdir@
+exec_prefix     = @exec_prefix@
+includedir      = @includedir@
+libdir          = @libdir@
+mandir          = @mandir@
+srcdir		= @srcdir@
+prefix          = @prefix@
+
+INSTALL		= @INSTALL@
+MKDIR_P		= @MKDIR_P@
+VPATH		= $(srcdir)
+RM		= rm -f
+
+FILES		= \
+		$(srcdir)/flowtest.tcl \
+		$(srcdir)/tool.xml
+
+destdir		= $(prefix)/examples/flow
+
+examples	= \
+		demo1 \
+		demo2 \
+		demo3
+
+all: 
+	for i in $(examples) ; do \
+	  $(MAKE) -C $$i all; \
+	done
+
+install: 
+	$(MKDIR_P) $(destdir)
+	for i in $(FILES) ; do \
+	  $(INSTALL) -m 444  $$i $(destdir) ; \
+	done
+	for i in $(examples) ; do \
+	  $(MAKE) -C $$i install; \
+	done
+
+clean:
+
+distclean: 
+	$(RM) Makefile *~
Index: /trunk/examples/flow/demo1/Makefile.in
===================================================================
--- /trunk/examples/flow/demo1/Makefile.in	(revision 1466)
+++ /trunk/examples/flow/demo1/Makefile.in	(revision 1466)
@@ -0,0 +1,35 @@
+
+bindir          = @bindir@
+datadir		= @datadir@
+datarootdir	= @datarootdir@
+exec_prefix     = @exec_prefix@
+includedir      = @includedir@
+libdir          = @libdir@
+mandir          = @mandir@
+srcdir		= @srcdir@
+prefix          = @prefix@
+
+INSTALL		= @INSTALL@
+MKDIR_P		= @MKDIR_P@
+VPATH		= $(srcdir)
+RM		= rm -f
+
+FILES		= \
+		$(srcdir)/demo1.tcl \
+		$(srcdir)/data-unirect3d.tcl \
+		$(srcdir)/tool.xml 
+
+destdir		= $(prefix)/examples/flow/demo1
+
+all: 
+
+install: 
+	$(MKDIR_P) $(destdir)
+	for i in $(FILES) ; do \
+	  $(INSTALL) -m 444  $$i $(destdir) ; \
+	done
+
+clean:
+
+distclean: 
+	$(RM) Makefile *~
Index: /trunk/examples/flow/demo2/Makefile.in
===================================================================
--- /trunk/examples/flow/demo2/Makefile.in	(revision 1466)
+++ /trunk/examples/flow/demo2/Makefile.in	(revision 1466)
@@ -0,0 +1,35 @@
+
+bindir          = @bindir@
+datadir		= @datadir@
+datarootdir	= @datarootdir@
+exec_prefix     = @exec_prefix@
+includedir      = @includedir@
+libdir          = @libdir@
+mandir          = @mandir@
+srcdir		= @srcdir@
+prefix          = @prefix@
+
+INSTALL		= @INSTALL@
+MKDIR_P		= @MKDIR_P@
+VPATH		= $(srcdir)
+RM		= rm -f
+
+FILES		= \
+		$(srcdir)/demo2.tcl \
+		$(srcdir)/data-unirect2d.tcl \
+		$(srcdir)/tool.xml 
+
+destdir		= $(prefix)/examples/flow/demo2
+
+all: 
+
+install: 
+	$(MKDIR_P) $(destdir)
+	for i in $(FILES) ; do \
+	  $(INSTALL) -m 444  $$i $(destdir) ; \
+	done
+
+clean:
+
+distclean: 
+	$(RM) Makefile *~
Index: /trunk/examples/flow/demo3/Makefile.in
===================================================================
--- /trunk/examples/flow/demo3/Makefile.in	(revision 1466)
+++ /trunk/examples/flow/demo3/Makefile.in	(revision 1466)
@@ -0,0 +1,35 @@
+
+bindir          = @bindir@
+datadir		= @datadir@
+datarootdir	= @datarootdir@
+exec_prefix     = @exec_prefix@
+includedir      = @includedir@
+libdir          = @libdir@
+mandir          = @mandir@
+srcdir		= @srcdir@
+prefix          = @prefix@
+
+INSTALL		= @INSTALL@
+MKDIR_P		= @MKDIR_P@
+VPATH		= $(srcdir)
+RM		= rm -f
+
+FILES		= \
+		$(srcdir)/demo3.tcl \
+		$(srcdir)/data-dx.tcl \
+		$(srcdir)/tool.xml 
+
+destdir		= $(prefix)/examples/flow/demo3
+
+all: 
+
+install: 
+	$(MKDIR_P) $(destdir)
+	for i in $(FILES) ; do \
+	  $(INSTALL) -m 444  $$i $(destdir) ; \
+	done
+
+clean:
+
+distclean: 
+	$(RM) Makefile *~