Index: /trunk/gui/apps/driver
===================================================================
--- /trunk/gui/apps/driver	(revision 1570)
+++ /trunk/gui/apps/driver	(revision 1571)
@@ -311,4 +311,10 @@
 	set type [$tool xml get tool.control.type]
     }
+    if { $type == "" } {
+        set arrangement [$win.pager cget -arrangement]
+        if { $arrangement != "side-by-side" } { 
+           set type auto
+        }
+    }
     if { $type == "auto" || $style == "wizard" } {
 	# in "auto" mode, we don't need a simulate button
Index: /trunk/packages/vizservers/configure
===================================================================
--- /trunk/packages/vizservers/configure	(revision 1570)
+++ /trunk/packages/vizservers/configure	(revision 1571)
@@ -641,5 +641,6 @@
 LD_RPATH
 CG_DIR
-DX_DIR
+DX_LIB_SPEC
+DX_INC_SPEC
 RP_DIR
 RP2_INCL_DIR
@@ -10063,32 +10064,61 @@
 
 
-{ $as_echo "$as_me:$LINENO: checking for DX installation" >&5
-$as_echo_n "checking for DX installation... " >&6; }
-DX_DIR=""
+{ $as_echo "$as_me:$LINENO: checking for OpenDX headers" >&5
+$as_echo_n "checking for OpenDX headers... " >&6; }
+DX_INC_DIR=""
 for dir in \
- /apps/rappture \
- /usr/dx \
- /usr
+ /apps/rappture/include \
+ /usr/dx/include \
+ /usr/include
 do
-  if test -r "${dir}/include/dx/dx.h" ; then
-    DX_DIR="$dir"
+  if test -r "${dir}/dx/dx.h" ; then
+    DX_INC_DIR="$dir"
     break
   fi
 done
-if test "x${DX_DIR}" = "x" ; then
-  { { $as_echo "$as_me:$LINENO: error: can't find OpenDX installation" >&5
-$as_echo "$as_me: error: can't find OpenDX installation" >&2;}
+if test "x${DX_INC_DIR}" = "x" ; then
+  { { $as_echo "$as_me:$LINENO: error: can't find OpenDX include files" >&5
+$as_echo "$as_me: error: can't find OpenDX include files" >&2;}
    { (exit 1); exit 1; }; }
 fi
 
-if test "${DX_DIR}" = "/usr" ; then
-  DX_DIR=""
-else
-  LD_RPATH="$loader_run_path:${DX_DIR}/lib"
-fi
-
-
-{ $as_echo "$as_me:$LINENO: result: ${DX_DIR}" >&5
-$as_echo "${DX_DIR}" >&6; }
+if test "${DX_INC_DIR}" = "/usr/include" ; then
+  DX_INC_SPEC=""
+else
+  DX_INC_SPEC="-I{DX_INC_DIR}"
+fi
+
+{ $as_echo "$as_me:$LINENO: result: ${DX_INC_DIR}" >&5
+$as_echo "${DX_INC_DIR}" >&6; }
+
+{ $as_echo "$as_me:$LINENO: checking for OpenDX libraries" >&5
+$as_echo_n "checking for OpenDX libraries... " >&6; }
+DX_LIB_DIR=""
+for dir in \
+ /apps/rappture/lib \
+ /usr/lib/dx/lib_linux \
+ /usr/dx/lib_linux \
+ /usr/lib
+do
+  if test -r "${dir}/libDXcallm.a" ; then
+    DX_LIB_DIR="$dir"
+    break
+  fi
+done
+if test "x${DX_LIB_DIR}" = "x" ; then
+  { { $as_echo "$as_me:$LINENO: error: can't find OpenDX libraries" >&5
+$as_echo "$as_me: error: can't find OpenDX libraries" >&2;}
+   { (exit 1); exit 1; }; }
+fi
+
+if test "${DX_LIB_DIR}" = "/usr" ; then
+  DX_LIB_SPEC=""
+else
+  DX_LIB_SPEC="-L${DX_LIB_DIR}"
+fi
+
+
+{ $as_echo "$as_me:$LINENO: result: ${DX_LIB_DIR}" >&5
+$as_echo "${DX_LIB_DIR}" >&6; }
 
 
Index: /trunk/packages/vizservers/configure.in
===================================================================
--- /trunk/packages/vizservers/configure.in	(revision 1570)
+++ /trunk/packages/vizservers/configure.in	(revision 1571)
@@ -159,28 +159,53 @@
 AC_CHECK_HEADERS([sys/socket.h sys/time.h netinet/in.h arpa/inet.h netdb.h])
 
-AC_MSG_CHECKING([for DX installation])
-DX_DIR=""
-for dir in \
- /apps/rappture \
- /usr/dx \
- /usr
+AC_MSG_CHECKING([for OpenDX headers])
+DX_INC_DIR=""
+for dir in \
+ /apps/rappture/include \
+ /usr/dx/include \
+ /usr/include
 do
-  if test -r "${dir}/include/dx/dx.h" ; then
-    DX_DIR="$dir"
-    break
-  fi
-done
-if test "x${DX_DIR}" = "x" ; then
-  AC_MSG_ERROR([can't find OpenDX installation])
-fi
-
-if test "${DX_DIR}" = "/usr" ; then
-  DX_DIR=""
+  if test -r "${dir}/dx/dx.h" ; then
+    DX_INC_DIR="$dir"
+    break
+  fi
+done
+if test "x${DX_INC_DIR}" = "x" ; then
+  AC_MSG_ERROR([can't find OpenDX include files])
+fi
+
+if test "${DX_INC_DIR}" = "/usr/include" ; then
+  DX_INC_SPEC=""
 else 
-  LD_RPATH="$loader_run_path:${DX_DIR}/lib"
-fi
-
-AC_SUBST(DX_DIR)
-AC_MSG_RESULT([${DX_DIR}])
+  DX_INC_SPEC="-I{DX_INC_DIR}"
+fi
+AC_SUBST(DX_INC_SPEC)
+AC_MSG_RESULT([${DX_INC_DIR}])
+
+AC_MSG_CHECKING([for OpenDX libraries])
+DX_LIB_DIR=""
+for dir in \
+ /apps/rappture/lib \
+ /usr/lib/dx/lib_linux \
+ /usr/dx/lib_linux \
+ /usr/lib
+do
+  if test -r "${dir}/libDXcallm.a" ; then
+    DX_LIB_DIR="$dir"
+    break
+  fi
+done
+if test "x${DX_LIB_DIR}" = "x" ; then
+  AC_MSG_ERROR([can't find OpenDX libraries])
+fi
+
+if test "${DX_LIB_DIR}" = "/usr" ; then
+  DX_LIB_SPEC=""
+else
+  DX_LIB_SPEC="-L${DX_LIB_DIR}"
+fi
+
+AC_SUBST(DX_LIB_SPEC)
+AC_MSG_RESULT([${DX_LIB_DIR}])
 
 AC_CHECK_HEADERS([ffmpeg/avcodec.h libavcodec/avcodec.h ffmpeg/avformat.h libavformat/avformat.h ffmpeg/avutil.h libavutil/avutil.h])
Index: /trunk/packages/vizservers/nanovis/FlowCmd.cpp
===================================================================
--- /trunk/packages/vizservers/nanovis/FlowCmd.cpp	(revision 1570)
+++ /trunk/packages/vizservers/nanovis/FlowCmd.cpp	(revision 1571)
@@ -1296,5 +1296,5 @@
 
     string = Tcl_GetString(objPtr);
-    p = strrchr(string, '%');
+    p = strrchr((char *)string, '%');
     if (p == NULL) {
 	float value;
Index: /trunk/packages/vizservers/nanovis/Makefile.in
===================================================================
--- /trunk/packages/vizservers/nanovis/Makefile.in	(revision 1570)
+++ /trunk/packages/vizservers/nanovis/Makefile.in	(revision 1571)
@@ -33,7 +33,6 @@
 CG_INC_SPEC     = -I$(CG_DIR)/include
 CG_LIB_SPEC     = -L$(CG_DIR)/lib -lCg -lCgGL
-DX_DIR          = @DX_DIR@
-DX_INC_SPEC     = -I$(DX_DIR)/include
-DX_LIB_SPEC     = -L$(DX_DIR)/lib_linux -lDXcallm
+DX_INC_SPEC      = @DX_INC_SPEC@
+DX_LIB_SPEC      = @DX_LIB_SPEC@ -lDXcallm
 FF_LIB_SPEC     = -lavformat -lavcodec -lavutil
 # might also need -lavutil
Index: /trunk/packages/vizservers/nanovis/RpAVTranslate.cpp
===================================================================
--- /trunk/packages/vizservers/nanovis/RpAVTranslate.cpp	(revision 1570)
+++ /trunk/packages/vizservers/nanovis/RpAVTranslate.cpp	(revision 1571)
@@ -293,5 +293,6 @@
 
 bool
-AVTranslate::allocPicture(Outcome &status, int pixFmt, AVFrame **framePtrPtr)
+AVTranslate::allocPicture(Outcome &status, PixelFormat pixFmt, 
+     AVFrame **framePtrPtr)
 {
     status.addContext("Rappture::AVTranslate::allocPicture()");
Index: /trunk/packages/vizservers/nanovis/RpAVTranslate.h
===================================================================
--- /trunk/packages/vizservers/nanovis/RpAVTranslate.h	(revision 1570)
+++ /trunk/packages/vizservers/nanovis/RpAVTranslate.h	(revision 1571)
@@ -46,5 +46,5 @@
 private:
     bool addVideoStream(Outcome &status, CodecID codecId, AVStream **stream);
-    bool allocPicture(Outcome &status, int pixFmt, AVFrame **pic );
+    bool allocPicture(Outcome &status, PixelFormat pixFmt, AVFrame **pic );
     bool openVideo(Outcome &status);
     bool writeVideoFrame(Outcome &status);
Index: /trunk/packages/vizservers/nanovis/VolumeRenderer.cpp
===================================================================
--- /trunk/packages/vizservers/nanovis/VolumeRenderer.cpp	(revision 1570)
+++ /trunk/packages/vizservers/nanovis/VolumeRenderer.cpp	(revision 1571)
@@ -350,5 +350,4 @@
 	
     } //iterate all volumes
-    fprintf(stderr, "total slices: %d\n", total_rendered_slices); 
     Trace("end loop\n");
     
Index: /trunk/packages/vizservers/nanovis/nanovis.cpp
===================================================================
--- /trunk/packages/vizservers/nanovis/nanovis.cpp	(revision 1570)
+++ /trunk/packages/vizservers/nanovis/nanovis.cpp	(revision 1571)
@@ -22,10 +22,10 @@
 #include <getopt.h>
 #include <iostream>
-#include <math.h>
+#include <cmath>
 #include <memory.h>
 #include <signal.h>
 #include <sstream>
-#include <stdio.h>
-#include <stdlib.h>
+#include <cstdio>
+#include <cstdlib>
 #include <string>
 #include <sys/resource.h>
@@ -2433,8 +2433,8 @@
 #ifdef XINETD
         path = argv[0];
-        p = strrchr(path, '/');
+        p = strrchr((char *)path, '/');
         if (p != NULL) {
             *p = '\0';
-            p = strrchr(path, '/');
+            p = strrchr((char *)path, '/');
         }
         if (p == NULL) {
Index: /trunk/src/core/RpEncode.cc
===================================================================
--- /trunk/src/core/RpEncode.cc	(revision 1570)
+++ /trunk/src/core/RpEncode.cc	(revision 1571)
@@ -212,5 +212,5 @@
     const char *cp, *endPtr;
     for (cp = buf, endPtr = buf + size; cp < endPtr; cp++) {
-        if (!_base64chars[*cp]) {
+        if (!_base64chars[(unsigned int)*cp]) {
 	    fprintf(stderr, "%c %d is not base64\n", *cp, *cp);
             return false;
Index: /trunk/src/core/RpOutcome.cc
===================================================================
--- /trunk/src/core/RpOutcome.cc	(revision 1570)
+++ /trunk/src/core/RpOutcome.cc	(revision 1571)
@@ -10,7 +10,8 @@
  * ======================================================================
  */
+#include <cstdarg>
+#include <cstdio>
+#include <cstdlib>
 #include "RpOutcome.h"
-#include <stdarg.h>
-#include <stdlib.h>
 using namespace Rappture;
 
Index: /trunk/src/core/RpUnits.cc
===================================================================
--- /trunk/src/core/RpUnits.cc	(revision 1570)
+++ /trunk/src/core/RpUnits.cc	(revision 1571)
@@ -15,4 +15,5 @@
 
 #include "RpUnits.h"
+#include <cstdio>
 #include <algorithm>
 